/**
 * Stops program progress for given amount of milliseconds.
 * 
 * NOTICE: This is NOT a good way to do this!
 * It is simple for a demonstration, but should not be used
 * in actual programs. 
 */
function sleep(milliseconds: number) {
    const timeWhenStarted = Date.now()
    let timeNow = Date.now()
    while (timeNow < timeWhenStarted + milliseconds) {
        timeNow = Date.now()
    }
}

// First version
const timeSinceInitializer1 = () => {
    const initialTime = Date.now()
    const timeSince = () => {
        const now = Date.now()
        const diff = now - initialTime
        const message = 'It has been ' + diff + ' ms since initialization'
        console.log(message)
    }
    return timeSince
}

const timeSince1 = timeSinceInitializer1()
sleep(1000)
timeSince1()


// Second version
const timeSinceInitializer2 = (includeInitialTime: boolean) => {
    const initialTime = Date.now()
    const timeSince = () => {
        const now = Date.now()
        const diff = now - initialTime
        let message = 'It has been ' + diff + ' ms since initialization'
        if (includeInitialTime) {
            const initialTimeString = new Date(initialTime).toISOString()
            message = message + ` (${initialTimeString})`
        }
        console.log(message)
    }
    return timeSince
}

const timeSince2 = timeSinceInitializer2(true)
sleep(1000)
timeSince2()

// Third version
const timeSinceInitializer3 = (includeInitialTime: boolean) => {
    const initialTime = Date.now()
    const timeSince = (messagePart1 = 'It has been ', messagePart2 = ' ms since initialization') => {
        const now = Date.now()
        const diff = now - initialTime
        let message = messagePart1 + diff + messagePart2
        if (includeInitialTime) {
            const initialTimeString = new Date(initialTime).toISOString()
            message = message + ` (${initialTimeString})`
        }
        console.log(message)
    }
    return timeSince
}


const timeSince3 = timeSinceInitializer3(true)
sleep(1000)
timeSince3('Holy Cow! It has been ', ' ms since the initialization!')